# TerminateInstance

## 1. API Description

This API is used to return an instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">Use this API to return an instance that is no longer required. A pay-as-you-go instance will stop billing after it is returns.</mark>
* <mark style="color:blue;">Calling this API on a subscription instance will cancel the subscription and the instance will be automatically returned after the subscription expires.</mark>
* <mark style="color:blue;">When this API is called, the instance will be moved to the recycle bin and be released in 24 hours if there are no other operations. You can also call</mark> [<mark style="color:purple;">`ReleaseInstances`</mark>](https://docs.console.zenlayer.com/api-reference/compute/bmc/bmc/releaseinstances) <mark style="color:blue;">to release the instance.</mark>
* <mark style="color:blue;">Operations on instances in recycle bin or in stalling status are not supported.</mark>
* <mark style="color:blue;">Operations on instances in</mark> <mark style="color:blue;">`CREATE_FAILED`</mark> <mark style="color:blue;">status will delete the instance directly. For prepaid instances, all payment amounts will be refunded.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description                                                                                                                                                                            |
| -------------- | -------- | ------ | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceId     | Yes      | String | <p>Instance ID.</p><p>To obtain the instance ID, you can call <a href="describeinstances"><code>DescribeInstances</code></a> and look for <code>instanceId</code> in the response.</p> |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                              |
| -------------- | ------ | -------------------------------------------------------------------------------------------------------- |
| requestId      | String | The unique request ID, which is returned for each request. RequestId is required for locating a problem. |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Return an instance with the ID:** `instanceId`

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: TerminateInstance
<Common Request Params>

Request:
{
  "instanceId": "instanceId"
}

Response:
{
  "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
  "response": {
    "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk) to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).​

| HTTP Status Code | Error Code                                      | Description                                                       |
| ---------------- | ----------------------------------------------- | ----------------------------------------------------------------- |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND                   | Instance does not exist.                                          |
| 403              | OPERATION\_DENIED\_INSTANCE\_RECYCLED           | Operations on instances in recycle bin are not supported.         |
| 403              | OPERATION\_DENIED\_INSTANCE\_CREATING           | Operations on instances in `CREATING` status are not supported.   |
| 403              | OPERATION\_DENIED\_INSTANCE\_STATUS\_INSTALLING | Operations on instances in `INSTALLING` status are not supported. |
| 403              | OPERATION\_DENIED\_INSTANCE\_SUBSCRIPTION       | Operations on subscription instances are not supported.           |
| 403              | OPERATION\_DENIED\_POSTPAID\_PROMISE            | Operations failed. Resources in commitment period.                |
